<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="de">
<head>
<!-- Generated by javadoc -->
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<title>BaseEventSource (Apache Commons Configuration 2.2 API)</title>
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="BaseEventSource (Apache Commons Configuration 2.2 API)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":10,"i9":10,"i10":10,"i11":10,"i12":10,"i13":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/BaseEventSource.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev&nbsp;Class</li>
<li><a href="../../../../../org/apache/commons/configuration2/event/ConfigurationErrorEvent.html" title="class in org.apache.commons.configuration2.event"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?org/apache/commons/configuration2/event/BaseEventSource.html" target="_top">Frames</a></li>
<li><a href="BaseEventSource.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.apache.commons.configuration2.event</div>
<h2 title="Class BaseEventSource" class="title">Class BaseEventSource</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">java.lang.Object</a></li>
<li>
<ul class="inheritance">
<li>org.apache.commons.configuration2.event.BaseEventSource</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Implemented Interfaces:</dt>
<dd><a href="../../../../../org/apache/commons/configuration2/event/EventSource.html" title="interface in org.apache.commons.configuration2.event">EventSource</a></dd>
</dl>
<dl>
<dt>Direct Known Subclasses:</dt>
<dd><a href="../../../../../org/apache/commons/configuration2/AbstractConfiguration.html" title="class in org.apache.commons.configuration2">AbstractConfiguration</a></dd>
</dl>
<hr>
<br>
<pre>public class <span class="typeNameLabel">BaseEventSource</span>
extends <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>
implements <a href="../../../../../org/apache/commons/configuration2/event/EventSource.html" title="interface in org.apache.commons.configuration2.event">EventSource</a></pre>
<div class="block"><p>
 A base class for objects that can generate configuration events.
 </p>
 <p>
 This class implements functionality for managing a set of event listeners
 that can be notified when an event occurs. It can be extended by
 configuration classes that support the event mechanism. In this case these
 classes only need to call the <code>fireEvent()</code> method when an event is to
 be delivered to the registered listeners.
 </p>
 <p>
 Adding and removing event listeners can happen concurrently to manipulations
 on a configuration that cause events. The operations are synchronized.
 </p>
 <p>
 With the <code>detailEvents</code> property the number of detail events can be
 controlled. Some methods in configuration classes are implemented in a way
 that they call other methods that can generate their own events. One example
 is the <code>setProperty()</code> method that can be implemented as a combination
 of <code>clearProperty()</code> and <code>addProperty()</code>. With
 <code>detailEvents</code> set to <b>true</b>, all involved methods will generate
 events (i.e. listeners will receive property set events, property clear
 events, and property add events). If this mode is turned off (which is the
 default), detail events are suppressed, so only property set events will be
 received. Note that the number of received detail events may differ for
 different configuration implementations.
 <a href="../../../../../org/apache/commons/configuration2/BaseHierarchicalConfiguration.html" title="class in org.apache.commons.configuration2"><code>BaseHierarchicalConfiguration</code></a> for instance has a custom implementation of
 <code>setProperty()</code>, which does not generate any detail events.
 </p>
 <p>
 In addition to &quot;normal&quot; events, error events are supported. Such
 events signal an internal problem that occurred during access of properties.
 They are handled via the regular <a href="../../../../../org/apache/commons/configuration2/event/EventListener.html" title="interface in org.apache.commons.configuration2.event"><code>EventListener</code></a> interface, but there
 are special event types defined by <a href="../../../../../org/apache/commons/configuration2/event/ConfigurationErrorEvent.html" title="class in org.apache.commons.configuration2.event"><code>ConfigurationErrorEvent</code></a>. The
 <code>fireError()</code> method can be used by derived classes to send
 notifications about errors to registered observers.
 </p></div>
<dl>
<dt><span class="simpleTagLabel">Since:</span></dt>
<dd>1.3</dd>
<dt><span class="simpleTagLabel">Version:</span></dt>
<dd>$Id: BaseEventSource.java 1790899 2017-04-10 21:56:46Z ggregory $</dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/event/BaseEventSource.html#BaseEventSource--">BaseEventSource</a></span>()</code>
<div class="block">Creates a new instance of <code>BaseEventSource</code>.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>&lt;T extends <a href="../../../../../org/apache/commons/configuration2/event/Event.html" title="class in org.apache.commons.configuration2.event">Event</a>&gt;<br>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/event/BaseEventSource.html#addEventListener-org.apache.commons.configuration2.event.EventType-org.apache.commons.configuration2.event.EventListener-">addEventListener</a></span>(<a href="../../../../../org/apache/commons/configuration2/event/EventType.html" title="class in org.apache.commons.configuration2.event">EventType</a>&lt;T&gt;&nbsp;eventType,
                <a href="../../../../../org/apache/commons/configuration2/event/EventListener.html" title="interface in org.apache.commons.configuration2.event">EventListener</a>&lt;? super T&gt;&nbsp;listener)</code>
<div class="block">Adds an event listener for the specified event type.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/event/BaseEventSource.html#clearErrorListeners--">clearErrorListeners</a></span>()</code>
<div class="block">Removes all registered error listeners.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/event/BaseEventSource.html#clearEventListeners--">clearEventListeners</a></span>()</code>
<div class="block">Removes all registered event listeners.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>protected <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/event/BaseEventSource.html#clone--">clone</a></span>()</code>
<div class="block">Overrides the <code>clone()</code> method to correctly handle so far
 registered event listeners.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/event/BaseEventSource.html#copyEventListeners-org.apache.commons.configuration2.event.BaseEventSource-">copyEventListeners</a></span>(<a href="../../../../../org/apache/commons/configuration2/event/BaseEventSource.html" title="class in org.apache.commons.configuration2.event">BaseEventSource</a>&nbsp;source)</code>
<div class="block">Copies all event listener registrations maintained by this object to the
 specified <code>BaseEventSource</code> object.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>protected <a href="../../../../../org/apache/commons/configuration2/event/ConfigurationErrorEvent.html" title="class in org.apache.commons.configuration2.event">ConfigurationErrorEvent</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/event/BaseEventSource.html#createErrorEvent-org.apache.commons.configuration2.event.EventType-org.apache.commons.configuration2.event.EventType-java.lang.String-java.lang.Object-java.lang.Throwable-">createErrorEvent</a></span>(<a href="../../../../../org/apache/commons/configuration2/event/EventType.html" title="class in org.apache.commons.configuration2.event">EventType</a>&lt;? extends <a href="../../../../../org/apache/commons/configuration2/event/ConfigurationErrorEvent.html" title="class in org.apache.commons.configuration2.event">ConfigurationErrorEvent</a>&gt;&nbsp;type,
                <a href="../../../../../org/apache/commons/configuration2/event/EventType.html" title="class in org.apache.commons.configuration2.event">EventType</a>&lt;?&gt;&nbsp;opType,
                <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;propName,
                <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;propValue,
                <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Throwable.html?is-external=true" title="class or interface in java.lang">Throwable</a>&nbsp;ex)</code>
<div class="block">Creates a <code>ConfigurationErrorEvent</code> object based on the passed in
 parameters.</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>protected &lt;T extends <a href="../../../../../org/apache/commons/configuration2/event/ConfigurationEvent.html" title="class in org.apache.commons.configuration2.event">ConfigurationEvent</a>&gt;<br><a href="../../../../../org/apache/commons/configuration2/event/ConfigurationEvent.html" title="class in org.apache.commons.configuration2.event">ConfigurationEvent</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/event/BaseEventSource.html#createEvent-org.apache.commons.configuration2.event.EventType-java.lang.String-java.lang.Object-boolean-">createEvent</a></span>(<a href="../../../../../org/apache/commons/configuration2/event/EventType.html" title="class in org.apache.commons.configuration2.event">EventType</a>&lt;T&gt;&nbsp;type,
           <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;propName,
           <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;propValue,
           boolean&nbsp;before)</code>
<div class="block">Creates a <code>ConfigurationEvent</code> object based on the passed in
 parameters.</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code>&lt;T extends <a href="../../../../../org/apache/commons/configuration2/event/ConfigurationErrorEvent.html" title="class in org.apache.commons.configuration2.event">ConfigurationErrorEvent</a>&gt;<br>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/event/BaseEventSource.html#fireError-org.apache.commons.configuration2.event.EventType-org.apache.commons.configuration2.event.EventType-java.lang.String-java.lang.Object-java.lang.Throwable-">fireError</a></span>(<a href="../../../../../org/apache/commons/configuration2/event/EventType.html" title="class in org.apache.commons.configuration2.event">EventType</a>&lt;T&gt;&nbsp;eventType,
         <a href="../../../../../org/apache/commons/configuration2/event/EventType.html" title="class in org.apache.commons.configuration2.event">EventType</a>&lt;?&gt;&nbsp;operationType,
         <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;propertyName,
         <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;propertyValue,
         <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Throwable.html?is-external=true" title="class or interface in java.lang">Throwable</a>&nbsp;cause)</code>
<div class="block">Creates an error event object and delivers it to all registered error
 listeners of a matching type.</div>
</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code>protected &lt;T extends <a href="../../../../../org/apache/commons/configuration2/event/ConfigurationEvent.html" title="class in org.apache.commons.configuration2.event">ConfigurationEvent</a>&gt;<br>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/event/BaseEventSource.html#fireEvent-org.apache.commons.configuration2.event.EventType-java.lang.String-java.lang.Object-boolean-">fireEvent</a></span>(<a href="../../../../../org/apache/commons/configuration2/event/EventType.html" title="class in org.apache.commons.configuration2.event">EventType</a>&lt;T&gt;&nbsp;type,
         <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;propName,
         <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;propValue,
         boolean&nbsp;before)</code>
<div class="block">Creates an event object and delivers it to all registered event
 listeners.</div>
</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code><a href="http://docs.oracle.com/javase/7/docs/api/java/util/List.html?is-external=true" title="class or interface in java.util">List</a>&lt;<a href="../../../../../org/apache/commons/configuration2/event/EventListenerRegistrationData.html" title="class in org.apache.commons.configuration2.event">EventListenerRegistrationData</a>&lt;?&gt;&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/event/BaseEventSource.html#getEventListenerRegistrations--">getEventListenerRegistrations</a></span>()</code>
<div class="block">Returns a list with all <code>EventListenerRegistrationData</code> objects
 currently contained for this event source.</div>
</td>
</tr>
<tr id="i10" class="altColor">
<td class="colFirst"><code>&lt;T extends <a href="../../../../../org/apache/commons/configuration2/event/Event.html" title="class in org.apache.commons.configuration2.event">Event</a>&gt;<br><a href="http://docs.oracle.com/javase/7/docs/api/java/util/Collection.html?is-external=true" title="class or interface in java.util">Collection</a>&lt;<a href="../../../../../org/apache/commons/configuration2/event/EventListener.html" title="interface in org.apache.commons.configuration2.event">EventListener</a>&lt;? super T&gt;&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/event/BaseEventSource.html#getEventListeners-org.apache.commons.configuration2.event.EventType-">getEventListeners</a></span>(<a href="../../../../../org/apache/commons/configuration2/event/EventType.html" title="class in org.apache.commons.configuration2.event">EventType</a>&lt;T&gt;&nbsp;eventType)</code>
<div class="block">Returns a collection with all event listeners of the specified event type
 that are currently registered at this object.</div>
</td>
</tr>
<tr id="i11" class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/event/BaseEventSource.html#isDetailEvents--">isDetailEvents</a></span>()</code>
<div class="block">Returns a flag whether detail events are enabled.</div>
</td>
</tr>
<tr id="i12" class="altColor">
<td class="colFirst"><code>&lt;T extends <a href="../../../../../org/apache/commons/configuration2/event/Event.html" title="class in org.apache.commons.configuration2.event">Event</a>&gt;<br>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/event/BaseEventSource.html#removeEventListener-org.apache.commons.configuration2.event.EventType-org.apache.commons.configuration2.event.EventListener-">removeEventListener</a></span>(<a href="../../../../../org/apache/commons/configuration2/event/EventType.html" title="class in org.apache.commons.configuration2.event">EventType</a>&lt;T&gt;&nbsp;eventType,
                   <a href="../../../../../org/apache/commons/configuration2/event/EventListener.html" title="interface in org.apache.commons.configuration2.event">EventListener</a>&lt;? super T&gt;&nbsp;listener)</code>
<div class="block">Removes the event listener registration for the given event type and
 listener.</div>
</td>
</tr>
<tr id="i13" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/event/BaseEventSource.html#setDetailEvents-boolean-">setDetailEvents</a></span>(boolean&nbsp;enable)</code>
<div class="block">Determines whether detail events should be generated.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a></h3>
<code><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#equals-java.lang.Object-" title="class or interface in java.lang">equals</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#finalize--" title="class or interface in java.lang">finalize</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#getClass--" title="class or interface in java.lang">getClass</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#hashCode--" title="class or interface in java.lang">hashCode</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#notify--" title="class or interface in java.lang">notify</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#notifyAll--" title="class or interface in java.lang">notifyAll</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#toString--" title="class or interface in java.lang">toString</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#wait--" title="class or interface in java.lang">wait</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#wait-long-" title="class or interface in java.lang">wait</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#wait-long-int-" title="class or interface in java.lang">wait</a></code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="BaseEventSource--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>BaseEventSource</h4>
<pre>public&nbsp;BaseEventSource()</pre>
<div class="block">Creates a new instance of <code>BaseEventSource</code>.</div>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="getEventListeners-org.apache.commons.configuration2.event.EventType-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getEventListeners</h4>
<pre>public&nbsp;&lt;T extends <a href="../../../../../org/apache/commons/configuration2/event/Event.html" title="class in org.apache.commons.configuration2.event">Event</a>&gt;&nbsp;<a href="http://docs.oracle.com/javase/7/docs/api/java/util/Collection.html?is-external=true" title="class or interface in java.util">Collection</a>&lt;<a href="../../../../../org/apache/commons/configuration2/event/EventListener.html" title="interface in org.apache.commons.configuration2.event">EventListener</a>&lt;? super T&gt;&gt;&nbsp;getEventListeners(<a href="../../../../../org/apache/commons/configuration2/event/EventType.html" title="class in org.apache.commons.configuration2.event">EventType</a>&lt;T&gt;&nbsp;eventType)</pre>
<div class="block">Returns a collection with all event listeners of the specified event type
 that are currently registered at this object.</div>
<dl>
<dt><span class="paramLabel">Type Parameters:</span></dt>
<dd><code>T</code> - the event type</dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>eventType</code> - the event type object</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a collection with the event listeners of the specified event type
         (this collection is a snapshot of the currently registered
         listeners; it cannot be manipulated)</dd>
</dl>
</li>
</ul>
<a name="getEventListenerRegistrations--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getEventListenerRegistrations</h4>
<pre>public&nbsp;<a href="http://docs.oracle.com/javase/7/docs/api/java/util/List.html?is-external=true" title="class or interface in java.util">List</a>&lt;<a href="../../../../../org/apache/commons/configuration2/event/EventListenerRegistrationData.html" title="class in org.apache.commons.configuration2.event">EventListenerRegistrationData</a>&lt;?&gt;&gt;&nbsp;getEventListenerRegistrations()</pre>
<div class="block">Returns a list with all <code>EventListenerRegistrationData</code> objects
 currently contained for this event source. This method allows access to
 all registered event listeners, independent on their type.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a list with information about all registered event listeners</dd>
</dl>
</li>
</ul>
<a name="isDetailEvents--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isDetailEvents</h4>
<pre>public&nbsp;boolean&nbsp;isDetailEvents()</pre>
<div class="block">Returns a flag whether detail events are enabled.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a flag if detail events are generated</dd>
</dl>
</li>
</ul>
<a name="setDetailEvents-boolean-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setDetailEvents</h4>
<pre>public&nbsp;void&nbsp;setDetailEvents(boolean&nbsp;enable)</pre>
<div class="block">Determines whether detail events should be generated. If enabled, some
 methods can generate multiple update events. Note that this method
 records the number of calls, i.e. if for instance
 <code>setDetailEvents(false)</code> was called three times, you will
 have to invoke the method as often to enable the details.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>enable</code> - a flag if detail events should be enabled or disabled</dd>
</dl>
</li>
</ul>
<a name="addEventListener-org.apache.commons.configuration2.event.EventType-org.apache.commons.configuration2.event.EventListener-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addEventListener</h4>
<pre>public&nbsp;&lt;T extends <a href="../../../../../org/apache/commons/configuration2/event/Event.html" title="class in org.apache.commons.configuration2.event">Event</a>&gt;&nbsp;void&nbsp;addEventListener(<a href="../../../../../org/apache/commons/configuration2/event/EventType.html" title="class in org.apache.commons.configuration2.event">EventType</a>&lt;T&gt;&nbsp;eventType,
                                               <a href="../../../../../org/apache/commons/configuration2/event/EventListener.html" title="interface in org.apache.commons.configuration2.event">EventListener</a>&lt;? super T&gt;&nbsp;listener)</pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../../org/apache/commons/configuration2/event/EventSource.html#addEventListener-org.apache.commons.configuration2.event.EventType-org.apache.commons.configuration2.event.EventListener-">EventSource</a></code></span></div>
<div class="block">Adds an event listener for the specified event type. This listener is
 notified about events of this type and all its sub types.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/event/EventSource.html#addEventListener-org.apache.commons.configuration2.event.EventType-org.apache.commons.configuration2.event.EventListener-">addEventListener</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../org/apache/commons/configuration2/event/EventSource.html" title="interface in org.apache.commons.configuration2.event">EventSource</a></code></dd>
<dt><span class="paramLabel">Type Parameters:</span></dt>
<dd><code>T</code> - the type of events processed by this listener</dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>eventType</code> - the event type (must not be <b>null</b>)</dd>
<dd><code>listener</code> - the listener to be registered (must not be <b>null</b>)</dd>
</dl>
</li>
</ul>
<a name="removeEventListener-org.apache.commons.configuration2.event.EventType-org.apache.commons.configuration2.event.EventListener-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>removeEventListener</h4>
<pre>public&nbsp;&lt;T extends <a href="../../../../../org/apache/commons/configuration2/event/Event.html" title="class in org.apache.commons.configuration2.event">Event</a>&gt;&nbsp;boolean&nbsp;removeEventListener(<a href="../../../../../org/apache/commons/configuration2/event/EventType.html" title="class in org.apache.commons.configuration2.event">EventType</a>&lt;T&gt;&nbsp;eventType,
                                                     <a href="../../../../../org/apache/commons/configuration2/event/EventListener.html" title="interface in org.apache.commons.configuration2.event">EventListener</a>&lt;? super T&gt;&nbsp;listener)</pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../../org/apache/commons/configuration2/event/EventSource.html#removeEventListener-org.apache.commons.configuration2.event.EventType-org.apache.commons.configuration2.event.EventListener-">EventSource</a></code></span></div>
<div class="block">Removes the event listener registration for the given event type and
 listener. An event listener instance may be registered multiple times for
 different event types. Therefore, when removing a listener the event type
 of the registration in question has to be specified. The return value
 indicates whether a registration was removed. A value of <b>false</b>
 means that no such combination of event type and listener was found.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/event/EventSource.html#removeEventListener-org.apache.commons.configuration2.event.EventType-org.apache.commons.configuration2.event.EventListener-">removeEventListener</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../org/apache/commons/configuration2/event/EventSource.html" title="interface in org.apache.commons.configuration2.event">EventSource</a></code></dd>
<dt><span class="paramLabel">Type Parameters:</span></dt>
<dd><code>T</code> - the type of events processed by this listener</dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>eventType</code> - the event type</dd>
<dd><code>listener</code> - the event listener to be removed</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a flag whether a listener registration was removed</dd>
</dl>
</li>
</ul>
<a name="clearEventListeners--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>clearEventListeners</h4>
<pre>public&nbsp;void&nbsp;clearEventListeners()</pre>
<div class="block">Removes all registered event listeners.</div>
</li>
</ul>
<a name="clearErrorListeners--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>clearErrorListeners</h4>
<pre>public&nbsp;void&nbsp;clearErrorListeners()</pre>
<div class="block">Removes all registered error listeners.</div>
<dl>
<dt><span class="simpleTagLabel">Since:</span></dt>
<dd>1.4</dd>
</dl>
</li>
</ul>
<a name="copyEventListeners-org.apache.commons.configuration2.event.BaseEventSource-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>copyEventListeners</h4>
<pre>public&nbsp;void&nbsp;copyEventListeners(<a href="../../../../../org/apache/commons/configuration2/event/BaseEventSource.html" title="class in org.apache.commons.configuration2.event">BaseEventSource</a>&nbsp;source)</pre>
<div class="block">Copies all event listener registrations maintained by this object to the
 specified <code>BaseEventSource</code> object.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>source</code> - the target source for the copy operation (must not be
        <b>null</b>)</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/IllegalArgumentException.html?is-external=true" title="class or interface in java.lang">IllegalArgumentException</a></code> - if the target source is <b>null</b></dd>
<dt><span class="simpleTagLabel">Since:</span></dt>
<dd>2.0</dd>
</dl>
</li>
</ul>
<a name="fireEvent-org.apache.commons.configuration2.event.EventType-java.lang.String-java.lang.Object-boolean-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>fireEvent</h4>
<pre>protected&nbsp;&lt;T extends <a href="../../../../../org/apache/commons/configuration2/event/ConfigurationEvent.html" title="class in org.apache.commons.configuration2.event">ConfigurationEvent</a>&gt;&nbsp;void&nbsp;fireEvent(<a href="../../../../../org/apache/commons/configuration2/event/EventType.html" title="class in org.apache.commons.configuration2.event">EventType</a>&lt;T&gt;&nbsp;type,
                                                        <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;propName,
                                                        <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;propValue,
                                                        boolean&nbsp;before)</pre>
<div class="block">Creates an event object and delivers it to all registered event
 listeners. The method checks first if sending an event is allowed (making
 use of the <code>detailEvents</code> property), and if listeners are
 registered.</div>
<dl>
<dt><span class="paramLabel">Type Parameters:</span></dt>
<dd><code>T</code> - the type of the event to be fired</dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>type</code> - the event's type</dd>
<dd><code>propName</code> - the name of the affected property (can be <b>null</b>)</dd>
<dd><code>propValue</code> - the value of the affected property (can be <b>null</b>)</dd>
<dd><code>before</code> - the before update flag</dd>
</dl>
</li>
</ul>
<a name="createEvent-org.apache.commons.configuration2.event.EventType-java.lang.String-java.lang.Object-boolean-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>createEvent</h4>
<pre>protected&nbsp;&lt;T extends <a href="../../../../../org/apache/commons/configuration2/event/ConfigurationEvent.html" title="class in org.apache.commons.configuration2.event">ConfigurationEvent</a>&gt;&nbsp;<a href="../../../../../org/apache/commons/configuration2/event/ConfigurationEvent.html" title="class in org.apache.commons.configuration2.event">ConfigurationEvent</a>&nbsp;createEvent(<a href="../../../../../org/apache/commons/configuration2/event/EventType.html" title="class in org.apache.commons.configuration2.event">EventType</a>&lt;T&gt;&nbsp;type,
                                                                        <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;propName,
                                                                        <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;propValue,
                                                                        boolean&nbsp;before)</pre>
<div class="block">Creates a <code>ConfigurationEvent</code> object based on the passed in
 parameters. This method is called by <code>fireEvent()</code> if it decides
 that an event needs to be generated.</div>
<dl>
<dt><span class="paramLabel">Type Parameters:</span></dt>
<dd><code>T</code> - the type of the event to be created</dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>type</code> - the event's type</dd>
<dd><code>propName</code> - the name of the affected property (can be <b>null</b>)</dd>
<dd><code>propValue</code> - the value of the affected property (can be <b>null</b>)</dd>
<dd><code>before</code> - the before update flag</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the newly created event object</dd>
</dl>
</li>
</ul>
<a name="fireError-org.apache.commons.configuration2.event.EventType-org.apache.commons.configuration2.event.EventType-java.lang.String-java.lang.Object-java.lang.Throwable-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>fireError</h4>
<pre>public&nbsp;&lt;T extends <a href="../../../../../org/apache/commons/configuration2/event/ConfigurationErrorEvent.html" title="class in org.apache.commons.configuration2.event">ConfigurationErrorEvent</a>&gt;&nbsp;void&nbsp;fireError(<a href="../../../../../org/apache/commons/configuration2/event/EventType.html" title="class in org.apache.commons.configuration2.event">EventType</a>&lt;T&gt;&nbsp;eventType,
                                                          <a href="../../../../../org/apache/commons/configuration2/event/EventType.html" title="class in org.apache.commons.configuration2.event">EventType</a>&lt;?&gt;&nbsp;operationType,
                                                          <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;propertyName,
                                                          <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;propertyValue,
                                                          <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Throwable.html?is-external=true" title="class or interface in java.lang">Throwable</a>&nbsp;cause)</pre>
<div class="block">Creates an error event object and delivers it to all registered error
 listeners of a matching type.</div>
<dl>
<dt><span class="paramLabel">Type Parameters:</span></dt>
<dd><code>T</code> - the event type</dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>eventType</code> - the event's type</dd>
<dd><code>operationType</code> - the type of the failed operation</dd>
<dd><code>propertyName</code> - the name of the affected property (can be
        <b>null</b>)</dd>
<dd><code>propertyValue</code> - the value of the affected property (can be
        <b>null</b>)</dd>
<dd><code>cause</code> - the <code>Throwable</code> object that caused this error event</dd>
</dl>
</li>
</ul>
<a name="createErrorEvent-org.apache.commons.configuration2.event.EventType-org.apache.commons.configuration2.event.EventType-java.lang.String-java.lang.Object-java.lang.Throwable-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>createErrorEvent</h4>
<pre>protected&nbsp;<a href="../../../../../org/apache/commons/configuration2/event/ConfigurationErrorEvent.html" title="class in org.apache.commons.configuration2.event">ConfigurationErrorEvent</a>&nbsp;createErrorEvent(<a href="../../../../../org/apache/commons/configuration2/event/EventType.html" title="class in org.apache.commons.configuration2.event">EventType</a>&lt;? extends <a href="../../../../../org/apache/commons/configuration2/event/ConfigurationErrorEvent.html" title="class in org.apache.commons.configuration2.event">ConfigurationErrorEvent</a>&gt;&nbsp;type,
                                                   <a href="../../../../../org/apache/commons/configuration2/event/EventType.html" title="class in org.apache.commons.configuration2.event">EventType</a>&lt;?&gt;&nbsp;opType,
                                                   <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;propName,
                                                   <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;propValue,
                                                   <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Throwable.html?is-external=true" title="class or interface in java.lang">Throwable</a>&nbsp;ex)</pre>
<div class="block">Creates a <code>ConfigurationErrorEvent</code> object based on the passed in
 parameters. This is called by <code>fireError()</code> if it decides that an
 event needs to be generated.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>type</code> - the event's type</dd>
<dd><code>opType</code> - the operation type related to this error</dd>
<dd><code>propName</code> - the name of the affected property (can be <b>null</b>)</dd>
<dd><code>propValue</code> - the value of the affected property (can be <b>null</b>)</dd>
<dd><code>ex</code> - the <code>Throwable</code> object that caused this error event</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the event object</dd>
</dl>
</li>
</ul>
<a name="clone--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>clone</h4>
<pre>protected&nbsp;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;clone()
                throws <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/CloneNotSupportedException.html?is-external=true" title="class or interface in java.lang">CloneNotSupportedException</a></pre>
<div class="block">Overrides the <code>clone()</code> method to correctly handle so far
 registered event listeners. This implementation ensures that the clone
 will have empty event listener lists, i.e. the listeners registered at an
 <code>BaseEventSource</code> object will not be copied.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Overrides:</span></dt>
<dd><code><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#clone--" title="class or interface in java.lang">clone</a></code>&nbsp;in class&nbsp;<code><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a></code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the cloned object</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/CloneNotSupportedException.html?is-external=true" title="class or interface in java.lang">CloneNotSupportedException</a></code> - if cloning is not allowed</dd>
<dt><span class="simpleTagLabel">Since:</span></dt>
<dd>1.4</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/BaseEventSource.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev&nbsp;Class</li>
<li><a href="../../../../../org/apache/commons/configuration2/event/ConfigurationErrorEvent.html" title="class in org.apache.commons.configuration2.event"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?org/apache/commons/configuration2/event/BaseEventSource.html" target="_top">Frames</a></li>
<li><a href="BaseEventSource.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy"><small>Copyright &#169; 2001&#x2013;2017 <a href="https://www.apache.org/">The Apache Software Foundation</a>. All rights reserved.</small></p>
</body>
</html>
